<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Document</title>
</head>
<body>
  <div id="app">

    <div v-if="isEditing === 'submit'">
        Name <br>
        <input type="text" v-model="name" ref="name"/> <br>
        Address  <br>
        <textarea v-model="address" ref="address"></textarea> <br>
        Phone Number <br>
        <input type="text" v-model="no_hp" ref="no_hp"/> <br> <br>
        <input style="width: 180px;" type="button" value="Submit" @click="submitForm()"/>
    </div>
    <div v-else-if="isEditing === 'edit'">
        Name <br>
        <input type="text" v-model="name" ref="name"/> <br>
        Address  <br>
        <textarea v-model="address" ref="address"></textarea> <br>
        Phone Number <br>
        <input type="text" v-model="no_hp" ref="no_hp"/> <br> <br>
        <input style="width: 180px;" type="button" value="Update"  @click="updateForm(member_id)"/>
        <input style="width: 180px;" type="button" value="Cancel"  @click="clearForm()"/>
    </div>
    <div v-else-if="isEditing === 'upload'">
        Name <br>
        <input type="text" v-model="name" ref="name" disabled/> <br>
        Address  <br>
        <textarea v-model="address" ref="address" disabled></textarea> <br>
        Phone Number <br>
        <input type="text" v-model="no_hp" ref="no_hp" disabled/> <br> <br>
        <input type="file" name="photo" ref="photo"> <br> <br>
        <input style="width: 180px; margin-bottom: 5px;" type="button" value="Upload" @click="submitPhoto(memberUpload_id)">
        <input style="width: 180px;" type="button" value="Cancel"  @click="clearForm()"/>
    </div>
    
    <br><br>

    <table border="1" v-for="member of members">
        <tr>
            <td>
                <img width="100" :src="member.photo_profile ? photoDomain + member.photo_profile : 'https://dummyimage.com/1920x1080/000/fff'" alt=""> &nbsp;&nbsp;
            </td>
            <td>{{ member.name }} &nbsp;&nbsp;</td>
            <td>{{ member.address }} &nbsp;&nbsp;</td>
            <td>{{ member.no_hp }} &nbsp;&nbsp;</td>
            <td>
                <button @click="editMember(member)">Edit</button>
                &nbsp;&nbsp;||&nbsp;&nbsp;
                <button @click="removeMember(member.id)">Delete</button>
                &nbsp;&nbsp;||&nbsp;&nbsp;
                <button @click="uploadPhoto(member)">Upload Photo</button>
                <br><br>
            </td>
        </tr>
    </table>
    
  </div>
  
  <script src="https://cdn.jsdelivr.net/npm/vue@2/dist/vue.js"></script>
  <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
  <script>
   var vm = new Vue({
      el: '#app',
      data: {
        isEditing: 'submit',
        member_id : null,
        memberUpload_id : null,
        name : '',
        address : '',
        no_hp : '',
        errors : [],
        members : [],
        photoDomain : 'http://demo-api-vue.sanbercloud.com'
      },
      computed: {

    },
    methods: {

        validationForm : function(){
            this.errors = []

            if(this.name.length == ''){
                this.errors.push('Nama belum terisi')
                this.$refs.name.focus()
            }

            if(this.address.length == ''){
                this.errors.push('Alamat belum terisi')
                this.$refs.address.focus()
            }

            if(this.no_hp.length == ''){
                this.errors.push('Nomor HP belum terisi')
                this.$refs.no_hp.focus()
            }
        },

        clearForm : function(){
            this.member_id = null;
            this.name = '';
            this.address = '';
            this.no_hp = '';
            this.memberUpload_id = null;
            this.isEditing = 'submit'
        },

        submitForm : function(){

            this.validationForm();

            if(this.errors.length === 0){

                let formData = new FormData();
                formData.append('name', this.name)
                formData.append('address', this.address)
                formData.append('no_hp', this.no_hp)

                const config = {
                    method : "post",
                    url : "http://demo-api-vue.sanbercloud.com/api/member",
                    data : formData
                }

                axios(config)
                .then( (response) => {
                    this.clearForm()
                    this.getMembers()
                    console.log(response.data);

                    alert(response.data.message)
                })
                .catch( (error) => {
                    console.log(error);
                })
                
            }
        },

        getMembers : function(){

            const config = {
                method : "get",
                url : "http://demo-api-vue.sanbercloud.com/api/member"

            }

            axios(config)
                .then( (response) => {
                    this.members = response.data.members;
                    console.log(response.data.members);
                })
                .catch( (error) => {
                    console.log(error);
                })

        },

        removeMember : function(id){

            const config = {
                method : "post",
                url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                params : { _method : "DELETE" }
            }

            axios(config)
                .then( (response) => {
                    this.getMembers()
                    alert(response.data.message);
                })
                .catch( (error) => {
                    console.log(error);
                })


            console.log(id);
        },

        editMember : function(member){
            this.isEditing = 'edit';
            this.member_id = member.id
            this.name = member.name
            this.address = member.address
            this.no_hp = member.no_hp

            console.log(member);
        },

        updateForm : function(id){
            this.validationForm()
            console.log(id)
            
            if(this.errors.length === 0){

            let formData = new FormData();
            formData.append('name', this.name)
            formData.append('address', this.address)
            formData.append('no_hp', this.no_hp)

            let config = {
                method : "post",
                url : `http://demo-api-vue.sanbercloud.com/api/member/${id}`,
                params : { _method : "PUT" },
                data : formData
            }

            axios(config)
            .then( (response) => {
                this.clearForm()
                this.getMembers()
                console.log(response.data);

                alert(response.data.message)
            })
            .catch( (error) => {
                console.log(error);
            })

            }

        },

        uploadPhoto : function(member){
            this.isEditing = 'upload';
            this.memberUpload_id = member.id
            this.name = member.name
            this.address = member.address
            this.no_hp = member.no_hp

        },
        
        submitPhoto : function(id){
            
            let file = this.$refs.photo.files[0]
            
            let formData = new FormData();
            formData.append('photo_profile', file)

            let config = {
                method : "post",
                url : `http://demo-api-vue.sanbercloud.com/api/member/${id}/upload-photo-profile`,
                data : formData
            }

            axios(config)
            .then( (response) => {
                this.clearForm()
                this.getMembers()
                console.log(response.data);
                this.isEditing = 'submit'

                alert(response.data.message)
            })
            .catch( (error) => {
                console.log(error);
            }) 
        }
    },

    created(){
        this.getMembers()
    }

  })
  </script>
</body>
</html>